\begin{frame}
    \frametitle{The models of consistency}
  
    \begin{columns}
      \column{0.6\textwidth}
      \footnote{Perrin, \emph{Concurrence et cohérence dans les systèmes répartis}, 2017}
      \resizebox{\columnwidth}{!}{
        \includegraphics{images/carte_criteres.png}
      }
  
      \column{0.4\columnwidth}
      \begin{block}{Les classes de cohérences}
        2 big family :
        \begin{itemize}
          \item Strong Consistency
          \item Weak Consistency :
          \begin{itemize}
            \item Eventual Consistency (EC)
            \item State Locality (SL)
            \item Validity (V)
          \end{itemize}
        \end{itemize}
      \end{block}
    \end{columns}
  \end{frame}
  
  \begin{frame}
    \frametitle{Eventual Consistency (EC)}
  
    \begin{block}{Definition}
        There exist a set of confinite operations where each one must be justify with the same state.  
    \end{block}
  
    \begin{columns}
      \column{0.4\columnwidth}
      \begin{tcolorbox}[colframe=green!50!black]
        \input{schemas/convergence_hc_1}
      \end{tcolorbox}
      \column{0.5\columnwidth}
      $E' = \{r/(1,2)^\omega, r/(1,2)^\omega\}$ \newline
      $\delta = ((1,2), \emptyset)$ is a valid state justifying $E'$.
    \end{columns}
  
    \begin{columns}
      \column{0.4\columnwidth}
      \begin{tcolorbox}[colframe=red!50!black]
        \input{schemas/convergence_hc_2}
      \end{tcolorbox}
      \column{0.5\columnwidth}
      $E' = \{r/(1,2)^\omega, r/(2,1)^\omega\}$. \newline
      There exist no state able to justify $E'$ because the two infinite read are not consistent.
    \end{columns}
  \end{frame}

  \begin{frame}
    \frametitle{State Locality}
  
    \begin{block}{Definition}
      For all $p$, there exist one linearization who include all the read operations of $p$. According to the local order of these reads. \\
    \end{block}
  
    \begin{columns}
      \column{0.4\columnwidth}
      \begin{tcolorbox}[colframe=green!50!black]
        \input{schemas/localiteetat_hc_1}
      \end{tcolorbox}
      \column{0.5\columnwidth}
      \begin{math}
        \begin{array}{l}
          \textcolor{blue}{C_{p_0} = \{r/(0,0), r/(0,2)^\omega, w(2)\}}, \\
          \textcolor{red}{C_{p_1} = \{r/(0,0), r/(0,1)^\omega, w(1)\}},  \\
          \textcolor{blue}{r/(0,0) \bullet w(2) \bullet r/(0,2)^\omega}  \\
          \textcolor{red}{r/(0,0) \bullet w(1) \bullet r/(0,1)^\omega}   \\
        \end{array}
      \end{math}
    \end{columns}
  
    \begin{columns}
      \column{0.4\columnwidth}
      \begin{tcolorbox}[colframe=red!50!black]
        \input{schemas/localiteetat_hc_2}
      \end{tcolorbox}
      \column{0.5\columnwidth}
      $E'_{p_0} = \{r/(0,0), r/(2,1)^\omega\},$ \newline
      $r/(0,0) \bullet w(2) \bullet w(1) \bullet r/(2,1)^\omega$  \newline
      $E'_{p_1} = \{r/(0,1), r/(2,1)^\omega\}$. \newline
      There exist no linearization of $p_1$ satisfying the definition of state locality
    \end{columns}
  \end{frame}
  
  \begin{frame}
    \frametitle{Validity (V)}
  
    \begin{block}{Definition}
        There exist a cofinite set of operations such as for each of them must be justified by a linearization of all the write operation.
    \end{block}
  
    \begin{columns}
      \column{0.4\columnwidth}
      \begin{tcolorbox}[colframe=green!50!black]
        \input{schemas/validite_hc_1}
      \end{tcolorbox}
      \column{0.5\columnwidth}
      \begin{math}
        \begin{array}{ll}
          E' = & \{r/(2,1)^\omega, r/(1,2)^\omega\}                             \\
               & w(2) \bullet w(1) \bullet \textcolor{red}{r/(2,1)^\omega} \\
               & w(1) \bullet w(2) \bullet \textcolor{red}{r/(1,2)^\omega} \\
        \end{array}
      \end{math}
    \end{columns}
  
    \begin{columns}
      \column{0.4\columnwidth}
      \begin{tcolorbox}[colframe=red!50!black]
        \input{schemas/validite_hc_2}
      \end{tcolorbox}
      \column{0.5\columnwidth}
      $E' = \{r/(0,1)^\omega, r/(1,2)^\omega\}$. \\
      There is no linearization of the write operation able to justify $r/(0,1)^\omega$.
    \end{columns}
  \end{frame}